#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "operacao.h"

void open_arquivos()
{
    FILE *file_entrada=NULL;
    FILE *file_saida=NULL;
    FILE *file_lojas=NULL;
    FILE *file_ex_clientes=NULL;
    FILE *file_pcf=NULL;
    FILE *file_clientes=NULL;
    struct datas data_temp;
    char c;
    int retorno = 2;
    struct lojas *lojas_head=NULL;
    struct clientes *head_clientes=NULL;
    struct pcf *head_pcf = NULL;


    //*******************ABRINDO ARQUIVOS*******************
    while (file_entrada == NULL)file_entrada = fopen ("arquivo_entrada.txt", "r");
    if (file_entrada == NULL)
    {
        printf ("***ERRO***\nArquivo de entrada nao foi aberto!");
    }

    while (file_saida == NULL) file_saida = fopen ("arquivo_saida.txt", "a+");
    if (!file_saida)
    {
        printf ("***ERRO***\nArquivo de saida nao foi aberto!");
    }
    while (file_lojas == NULL)file_lojas = fopen ("arquivo_lojas.txt", "r");
    if (!file_lojas)
    {
        printf ("***ERRO***\nArquivo de lojas nao foi aberto!");
    }

    while (file_ex_clientes == NULL) file_ex_clientes = fopen ("arquivo_ex_clientes.txt", "r");
    if (!file_ex_clientes)
    {
        printf ("***ERRO***\nArquivo de ex-clientes nao foi aberto!");
    }

    while (file_pcf == NULL)file_pcf = fopen ("arquivo_pcf.txt", "r");
    if (!file_pcf)
    {
        printf ("***ERRO***\nArquivo de PCF nao foi aberto!");
    }

    while (file_clientes == NULL) file_clientes = fopen ("arquivo_clientes.txt", "r");
    if (!file_clientes)
    {
        printf ("***ERRO***\nArquivo de clientes nao foi aberto!");
    }




    //ALOCANDO LOJAS, CLIENTES, PCF, E AS LISTAS ENCADEADAS
    head_clientes = encadear_clientes(file_clientes, head_clientes);//le o arquivo de clientes incicial e encadeia os clientes ja existentes

    lojas_head = encadear_lojas (file_lojas, lojas_head);//Le o arquivo de lojas inicial e encadeia as lojas ja existentes

    head_pcf = (struct pcf*) calloc (1, sizeof (struct pcf));
    head_pcf = encadear_pcf (file_pcf, head_pcf);



    //TESTE**********************************************************************
    head_clientes->pagar_meses = (struct pagar*) calloc (1, sizeof (struct pagar));
    head_clientes->pagar_meses->mes_atual = 340,00;
    head_clientes->pagar_meses->next = (struct pagar*) calloc (1, sizeof (struct pagar));
    head_clientes->pagar_meses->next->mes_atual = 320.23;
    head_clientes->pagar_meses->next->next = NULL;
    //*******************************************************************************


    fseek (file_entrada, 0, SEEK_SET);

    while (retorno == 2)
    {
        do
        {

            c = getc (file_entrada);
        }
        while (c != '*' && c != EOF );//ENCONTRA O MARCADOR DE DATA


        if (c == EOF)
        {
            printf ("\nFIM DE OPERACOES\n");
            fputs ("\nFIM DE OPERACOES",file_saida);
            break;
        }
        get_data(file_entrada, &data_temp);//PEGA DATA E GUARDA NO STRUCT
        printf ("\n");
        printf (data_temp.data_toda);
        printf ("\n");
        fprintf (file_saida, "\n%s\n", data_temp.data_toda);//IMPRIMINDO DATA NO ARQUIVO_SAIDA

        //IDENTIFICA OPERAO  RETORNA 1 SE FIM DO EXPEDIENTE FOR ENCONTRADO (^)
        do
        {
            retorno = get_operacao(file_entrada, file_saida, file_lojas, &head_clientes, &lojas_head, file_clientes, data_temp, head_pcf);
        }
        while (retorno == 1);



        verificar_data (&data_temp, head_clientes, file_saida);

    }

    fclose (file_clientes);
    fclose (file_lojas);

    //IMPRIMIR NOS ARQUIVOS
    imprimir_clientes (head_clientes, file_clientes);
    imprimir_lojas (lojas_head, file_lojas);


    fclose (file_entrada);
    fclose (file_saida);
}

void get_data(FILE *file_entrada,struct datas *data)
{
    fscanf (file_entrada, "%d", &data->dia);
    fseek (file_entrada, 1, SEEK_CUR);
    fscanf (file_entrada, "%d", &data->mes);
    fseek (file_entrada, 1, SEEK_CUR);
    fscanf (file_entrada, "%d", &data->ano);
    fseek (file_entrada, -10, SEEK_CUR);
    fread (data->data_toda, sizeof (char), 11, file_entrada);
    data->data_toda[11] = '\0';
}

int get_operacao(FILE *file_entrada, FILE *file_saida, FILE *file_lojas,struct clientes**head_clientes, struct lojas** lojas_head, FILE* file_clientes,struct datas data_atual,struct pcf *head_pcf)
{
    char c, operacao[100];
    int i;
    char op1[] = "Cadastrar Cliente";
    char op2[] = "Cadastrar Loja";
    char op3[] = "Atualizar Cadastro";
    char op4[] = "Compra";
    char op5[] = "Excluir Cliente";

    do
    {

        c = getc (file_entrada);
        if (c=='^')//ENCONTRA O MARCADOR DE FIM DE EXPEDIENTE
        {
            printf (" FIM DO EXPEDIENTE\n");
            fputs ("\nFIM DO EXPEDIENTE\n", file_saida);
            return 2;
        }
    }
    while (c != '-');

    fgets (operacao, 100, file_entrada);
    for (i=0; i<100; i++)
    {
        if (operacao[i] == '\n' || operacao[i] == '\r' || operacao[i] == '\0')
        {
            operacao[i] = '\0';
            break;
        }
    }


    if (strcmp (operacao, op1) == 0) cadastrar_cliente(file_entrada, file_saida,*head_clientes, head_pcf, data_atual);
    else if (strcmp (operacao, op2) == 0) cadastrar_loja(file_entrada, file_saida, lojas_head);//IMRPIME ARQUIVOS_LOJAS, ARQUIVO_SAIDA
    else if (strcmp (operacao, op3) == 0) atualizar_cadastro (*head_clientes, file_entrada, file_saida);
    else if (strcmp (operacao, op4) == 0) adm_compra (head_clientes, lojas_head, file_entrada, file_saida);
    else if (strcmp (operacao, op5) == 0) excluir_cliente(file_entrada, *head_clientes, file_saida);


    return 1;
}
